c
c                   PREMOS (Powder version of REMOS)
c
c                   rietvelt analysis and simulation of
c                       powder diffraction patterns
c
c             copyright (c) aug. 1988  by Akiji Yamamoto
c
c                       input data instruction
c
c        ******data for simulation is inserted here******
c        (00) job,ids
c             job : 0 rietvelt analysis, 1 simulation
c                   2 plot experimental data
c             ids : number of data sets for observed intensity
***********************************************************************
c*       (01) lgr, (iset)
c*            laue group: m3m,m3,4/mmm,4/m,mmm,2/m,-1,6/mmm,6/m,-3m,-31
c*               laue group (number of equivalent positions)
c*           m3m(48),m3(24),4/mmm(16),4/m(8),mmm(8),2/m(4),-1(2)
c*                  6/mmm(24),6/m(12),-3m(12),-31(6)
c*             *** if 2/m then iset : setting ***
c*             for 2/m first, second or third setting (c, b or a axis unique)
c*                     and third setting (a unique)
c*       (02)   mmax(1),mmax(2),mmax(3), riccut
c*              mmax : maximum satellite indices generated
c*                     (for each substructure)
c*              riccut: if I/Imax < riccut, it is dropped in the calculation
c*                                        of the powder pattern
c*                             (default 0.001)
c*       (03)   ih1,ih2,itpype1,itype2
c                  ih1:    hkl for first preferred orientation axis
c                  ih2:    hkl for second preferred orientation axis
c                  itype1   1, 2 or 3   ****see (017)****
c                  itype2   1 disk-like, 2 rod-like for itype1=1 and 2
c*       (04)   ldev 1 for B/W 2 for color PostScript printer
***********************************************************************
c        (05) xray, ibackgr
c              xray:  mo,zn,cu,ni,co,fe,cr,tn,tf
c                 ****tn: thermal neutron or syncrotron xray****
c                 ****tf: time of flight neutron*****
c              ibackgr=0 or 1  chooses a background function 
c                pb(0) : scale factor
c                x : 2-theta in degree
c                t:  theta in radian
c                y=(2*x-qmax-qmin)/(qmax-qmin)   ! normalized 2-theta
c                Q=4*pi*sin(t)/lambda=2*pi*q
c                pn(i,y): i-th Legendre polynomial
c                for ibkgr=0
c                     backgr=sum(n=1,12) pb(n)*pn(n,y)*1000   
c                for ibkgr=1
c                     backgr=sum(n=1,6) pb(n)*pn(n,y)*1000+
c                      sum(n=7,9,11) pb(n)*sin(Q*pb(n+1))/(Q*pb(n+1))*1000
c                ibackgr=0 for normal background
c                ibackgr=1 for removing several broad humps
c                       from glass component or other materials
c                       in which pb(8),pb(10),pb(12) should be positive
c                       but pb(7),pb(9),pb(11) can be zero if not
c                       necessary
c        (06)    qmin,qmax,qint,nrange,ixax,ilp,alpha :
c                qmin,qmax: minimum and maximum 2-theta angle (deg)
c                        for xray=  mo,zn,cu,ni,co,fe,cr,tn
c                or (diffraction vector)*2*pi (inverse angstrome)
c                        for xray=tf (see 01)
c                qint: interval of observed data
c                         (degree or inverse angstrome)
c             *****qint is meaningless for xray=tf and job=0****
c                nrange: number of used ranges : 0 means all the range
c                         **** 0<=nrange<=20 ****
c                ixax: 1 xaxis=2-theta 0: xaxis=2*pi*q (q:diffraction vector)
c                ilp : 0 lp-corrction for thermal neutron (cylindrical sample)
c                      1 lp-correction for diffractometer (flat sample)
c                     -1 lp-correction for diffractometer (flat sample)
c                        with auto-divergence slit (G=sin(theta))
c                      2 lpg-correction for Guinier diffractometer
c                      3 KEK asymmetric diffraction SOR (95% polalized X-ray)
c                      4 ESRF SOR (symmetric) (96% polalized X-ray)
c                              (cylindrical sample)
c                alpha: fixed incident angle for ilp=3  (8.0 degree in KEK)
c        (06')
c             if xray=tn,
c             wavl    (wave length of neutron)
c               ******  if(nrange.ne.0) *******
c        (07)               (usrmn,usrmx)
c                usrmn: beginning of used range (default qmin)
c                usrmx: end of used range       (default qmax)
c                 *****repeat (031) nrange times****
c        (08)    thbm, fi
c                thbm: bragg angle of monochrometor (deg)
c                fi  : angle between the normal to the specimen
c                      plane and the primary beam in Guinier method (deg)
c        (09)    lenx,leny,vscl,delta
c                lenx, leny: length of x and y axes
c                vscl: vertical scale
c                delta: interval of x axis scale
c        (010)   pb: scale and background parameters (pb(0)-pb(12))
c         if xray .ne. tf   (individual Pseudo Void function 
c                            for lower and higher angle parts)
c           (011)  si (s1,s2,u1,v1,u2,v2)
c                  sigma1=s1*sqrt(1+u1*q+v1*q**2)
c                  sigma2=s2*sqrt(1+u2*q+v2*q**2)
c           (012)  gi  (g1,g2)
c                  gamma1=g1
c                  gamma2=g2
c           (013)   rsi : ratio of gaussian line width
c                          for satellite with respect to those of main
c         else if xray .eq. tf
c           (011)  si (s1,s2,u1,v1,u2,v2)
c                  sigma1=s1*sqrt(1+u1*q+v1*q**2)
c                  sigma2=s2*sqrt(1+u2*q+v2*q**2)
c           (012)  gi  (g1,g2,g3)
c                  gamma1=g1          long tail
c                  gamma2=g2*q**2+g3  short tail
c           (013)  ri   (r1,r2)
c                  R=exp(-r1*q**r2)
c           (014)  rs1: ratio of s1 and s2
c                       for satellite with respect to those of main
c        (016)  sgm :absorption corrction parameter
c                   (assuming transmission geometry)
c               for ilp != 2, absorption correction is neglected
c        (017)  pg    : extinction parameter
c        (018)   prefered orientation parameters p1,p2,p3,p4
c        for itype1=1
c           pof=(p1+(1-p1)*p2*ang0**2*exp(-p2*ang1**2)/(1-exp(-p2*ang0**2)))
c              *(p3+(1-p3)*p4*ang0**2*exp(-p4*ang2**2)/(1-exp(-p4*ang0**2)))
c               ang0=pi/2
c        for itype1=2
c           pof=p1*exp(-p1*m1**2-p2*(n2**4+n3**4))/(1-exp(-p1))
c              n1=cos(ang), m1=sin(ang)
c        if xray .ne. tf
c            (019)  zps:   zero point shift
c        else
c            (019)  c0,c1,c2
c
c        (020)   nlp: (number of lattice parameters <=15)
c        (021)   constraint condition for lattice parameters
c                i,cf,ic,[i,cf,ic.....]  (5(i2,f9.5,a1))
c                i: a,b,or c (i<+3), 4 cosa, 5 cosb, 6 cosc, 7 k1, 8 k2, 9 k3
c                   10 k1, 11 k2 12 k3 13 k1 14 k2 15 k3
c               (k1, k2, k3 : a*, b*, c* components of first, second
c                             and third wave vectors [ if any ])
c               ****** repeat (021) nlp times ******
c        (022)    input io data file name   (a)
c         ******************file format************************
c                    intensity         (f12.6) for X-ray
c                    intensity 2-theta (2f12.6) for thermal neutron and SOR
c                    intensity Q       (2f12.6) for TOF neutron
c
c                     for job=0, give dummy name
c               ****** repeat (022) ids times ******
c      ******************data for remos*******************
c     (01) iwflag
c          iwflag(1): 0 output default lists
c             default iwflag  see below
c             iwflag(2)=1, iwflag(3)=1, iwflag(4)=4, iwflag(5)=2,
c             iwflag(6)=3
c                   : 1 output selected list according to the
c                       following
c          iwflag(2): 1 output title
c          iwflag(3): 1 output other input data
c          iwflag(4): 1 output fourier amplitudes in each cycle
c                   : 2 output their difference in each cycle
c                   : 3 output both in each cycle
c                   : 4 output fourier amplitudes in first and
c                       last cycles
c          iwflag(5): 1 output independent parameters in each cycle
c                   : 2 output their difference in each cycle
c                   : 3 output both in each cycle
c          iwflag(6): 1 output standard dev. of independent param.
c                   : 2 output standard dev. of fourier amplitudes
c                   : 3 output both
c          iwflag(7): 1 output correlation matrix
c
c     (02)    input hkl data file name   (a)
c     (03)    independent parameter file name (a)
c     (04)    fo data output file name (a)
c     (05)    output fc data file name (a)
c
c     (1) title
c
c     (2) a b c cosa cosb cosc
c     (3) na , nsub,  zmtrx
c         na: number of independent atoms in an asymmetric unit
c             of the aberage (fundamental) structure (1<=na<=200)
c         nsub: number of subsystems  
c               (for usual modulated structure nsub=1)
c               (for composite crystals, 2 <= nsub <=3)
c         zmtrx(1-6): permutation for the second to nsub-th subsystems
c         for example 1 3 4 2 5 6   2 3 5 1 4 6 means that 
c             a1*, a3*, a4* and a2*, a3*, a5* span the reciprocal lattices
c             for the second and third substructures
c             (for the first substructure 1 2 3 4 5 6 is assumed)
c
c     (4) no,symbol,sft,x1-x6,mpl              (i2,a6,i2,7f9.6)
c         no: atom number
c         symbol: symbol of the atomic site
c         stf: scattering-factor-table number
c         x1-x6: atomic coordinates
c         mpl: multiplicity
c          =========== repeat (4) na times ===========
c
c     (5) ndm,nsymo,icent,ige,nctr
c         ndm: dimension of modulation     (1<=ndm<=3)
c         nsymo: number of symmetry operators in modulated structure
c                 (1<=nsymo<=48)
c         icent=0: noncentrosymmetric, =1: centrosymmetric
c           if centrosymmetric take the origin at center of symmetry
c           and give symmetry operators in the factor group, g/i
c           ige=0: give all symmetry opeators, ige=1: give generators,
c           then all elements are created in the program
c         nctr: number of centering translations  (0<=nctr<=48)
c               nctr=0 means primitive lattice
c
c     (6)  a*,b*,c* components of the wave vector icorc, ilm (*)
c         if incommensurate icorc=1, commensurate icorc=0
c         ilm  number of divisions of gauss integrals in structure
c         factor formula in incommensurate cases     3<=ilm<=100
c           =========== repeat (6) ndm times ============
c
c           if all the wave vectors are incommensurate
c                          skip (7)
c **************data for the commensurate structure*********************
c *       if anyone of wave vectors is commensurate,                   *
c *   (7)  ilc:  give period along a,b,c axes                          *
c **********************************************************************
c           if(nctr=0) skip (8)
c     (8) 'centering translation'
c           in the format of I.T.   (excluding 0,0,0,0,0,0)
c           1/2,1/2,0,1/2  etc.
c           =========repeat (8) nctr times ========
c     (9) symmetry operatores in modulated structure
c              in the format of I.T.
c              for example x,y,z,t,u,v or
c                          -x+1/2,y,z,t+1/2,u+1/2,v etc
c           ======== repeat (9) nsymo times ==========
c         ****the first operator must be the identity operator****
c         ****the symmetry operator is used to classify the
c                            satellite reflections    see (37)******
c
c                    if nextnc=0 skip (10)
c *****data to specify extinction rules for general reflections********
c *    (10)  mi (mi(1)-mi(idm+1) of reflection condition              *
c *           mi(1)*h1+mi(2)*h2+...=mi(idm+1)*n                       *
c *         ======== repeat (10) nextnc times =========               *
c *********************************************************************
c
c     (11) ix,ib,if,nds,nzc,nw,nt,ipol,ipnf1,ipnf2,itvr,itst,nxmax
c         ix: maximum no. of independent parm. for displacement
c         ib: maximum no. of independent parm. for temperature factor
c         if: maximum no. of independent parm. for scattering factor
c             ix,ib,if are used for memory design
c             number of independent parameters is counted
c                          in (28) and (29)
c         nds: no. of data sets ( no. of scale factprs )  (1<=nds<=20)
c                   this is ignored in pwplot
c         nzc: upper limit of the number of coefficients which relate
c          constrained atomic parameters and independent parameters
c         nw: no. of fourier terms
c         nt: upper limit of the number of sin and cos functions
c             included in a fourier term
c         ipol=1, differenciation is made in the poler coordinate
c            then give each complex amplitude of modulation waves
c            in order of re and im parts.
c         ipnf1>0,the penalty function is used for the
c            occupation probability (see (37))
c         ipnf1=1 limits upper and lower sides while
c         ipnf1=2 limits lower side of occupation probability
c         ipnf2=1,penalty function is used for the interatomic distance
c                         (see (35))
c         itvr: no. of parameters for domain size
c         itst:  no. of parameters for out of step
c         nxmax: upper limit of no. of variable parameter in each block
c                                                   (see (33))
c
c     (12) dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,isext 
c          dspmdl=1 displasive modulation exists otherwise =0
c          tmpmdl=1 temp.fact. modulation exists otherwise =0 then b=0
c          sctmdl=1 density modulation exists otherwise =0 then p=1
c          sctmdl=-1 means substitutional modulation
c            then give the occupation probability of the first atom
c            the occupation probability of the second atom is given
c            by 1-p  (see 16)
c          itempf=0 isotropic temperature factor for all atoms
c          itempf=1 anisotropic temperatire factor Bij for all atoms
c          itempf=2 anisotropic temperatire factor Uij for all atoms
c          itempf=-1 some atoms anisotropic Bij and others isotropic B
c          itempf=-2 some atoms anisotropic Uij and others isotropic B
c          abs(itwin) nomber of twin domains
c             itwin.gt.0 macroscopic twin
c             itwin.lt.0 microscopic twin
c          iphfl=1 phase fluctuations between microscopic domains
c          iphfl=0 no such phase fluctuations
c          isext=1 secondary extinction correction =0 no ext. corr.
c
c                       if itempf >= 0 skip (13)
c ***********data to specify anisotropic temperature factor*************
c *    specify atoms with anisotropic temp.fact.                       *
c *    (13) (itfs(i),i=1,na)  (80i1)                                   *
c *    itfs(i)=0:temp.factor of i-th atom is isotropic,=1: anisotropic *
c **********************************************************************
c
c                     if itwin=0 skip (14)
c ************data for the case of twined crystals**********************
c *    (14) twin operator                                              *
c *            in the format of I.T.                                   *
c *         ========== repeat (14) abs(itwin) times  =========         *
c **********************************************************************
c
c     (15) ne,iand,inpd 
c          ne: number of atomic-scattering-factor tables
c          iand: give 1 when the anomalous dispersion correction is
c                made, otherwise, give 0.
c          inpd: give 0 when atomic scattering table is given
c                give 1 when coefficients of 4-exponental-function
c                approximation of the atomic scattering factoris are
c                given
c
c     (16) atomic scattering factor table with interval of 0.05
c          (asct(i),i=1,35) (12f6.3) or the coeffecients
c          (a(i),b(i),i=1,4),c  (9f8.5)
c
c                         if iand=0 skip (17)
c**********************************************************************
c*    (17) real and imaginary parts of anom. disp. cor.               *
c*                                                    (2f8.5)         *
c**********************************************************************
c                       if sctmdl>=0 skip (18)-(19)
c**********************************************************************
c*    (18) atomic scattering factor for the second species            *
c*         in the same site                            (12f6.3)       *
c*           the format is the same as in (16)                        *
c*                                                                    *
c*    (19) real and imaginary parts of the anomarous dispersion       *
c*             correction for the second species       (2f8.5)        *
c**********************************************************************
c
c      ============== repeat (16)-(19)) ne times =================
c
c                     if ipnf2=0 skip (20)-(21)
c***********data for the second penalty function, pf2*******************
c*    (20) number of bond distances (nb)                               *
c*    (21) atom1,atom2,nsym,icnt,(tdr(i),i=1,6) dmin,dmax,icont        *
c*                                 (4i3,8f8.6,i3)                      *
c*         atom1: atom number of the first atom in a pair              *
c*         atom2: atom number of the second atom(see below)            *
c*         nsym: symmetry operator number which generate from atom2    *
c*               the second atom in a pair                             *
c*         icnt: if the second atom in a pair is generated by the      *
c*               combination of the avobe operator and the inversion   *
c*               then icnt=1, otherwise icnt=0                         *
c*         trd(i) a,b,c components of an additional translation vector *
c*                after the inversion if icnt=1                        *
c*         dmin: minimum interatomic distance allowed                  *
c*         dmax: maximum interatomic distance allowed                  *
c*          when aberage bond distances are constrained,               *
c*           repeat (14) by the number of bond distances to be averaged*
c*           then last dmin and dmax are regarded as the limit of      *
c*           average bond distances and 1 must be given for icont      *
c*           excluding the last line of each group.  the program counts*
c*           the number of pairs by icont                              *
c*                      repeat (21) nb times                           *
c***********************************************************************
c
c                    if isext=0 skip (22)-(26)
c ***********data for absorption and extinction corrections*************
c *       the bisecting position (omega=0) is assumed                  *
c *        (busing et al. 1967, acta cryst. 22, 475.)                  *
c *   (22) nbf,mp,mq,mr,icm                                            *
c *        nbf: number of equations designating boundary conditions    *
c *           nbf.eq.1  ellipsoidal crystal                            *
c *           nbf.gt.1  polyhedral crystal                             *
c *       mp,mq,mr: number of divisions along x,y,z axes in integral   *
c *       icm:  (see 24)                                               *
c *             mp*mq*mr<=1000 ******related common variables          *
c *               common /extcr2/ ex,ey,ez,wxyz                        *
c *   (23)  aa,bb,cc,ff                       (4f8.5)                  *
c *      boundary cond. aa*x**2+bb*y**2+cc*z**2=ff or aa*x+bb*y+cc*z=ff*
c *       (x,y,z in cm and ff must be positive)                        *
c *                  repeat (22) by nbf times                          *
c *                                                                    *
c *   (24) wv,abc0,bth,amag                                            *
c *       wv: wave length in 10**-8 cm (should be equal to (01))       *
c *       abc0: linear absorption coefficient in cm**-1                *
c *       bth: bragg angle for monochrometer in degree                 *
c *          (if monochrometer is not used  bth=0)                     *
c *       amag: magnification of calculated structure factors          *
c *                                                                    *
c *   (25) ((cm(i,j),j=1,3),i=1,3)  (9f8.5)                            *
c *       cm cell orientation matrix  (ub or u matrix)                 *
c *          if(icm.eq.0)   cm : ub matrix                             *
c *          (hx/hy/hz)=cm*(h/k/l)                                     *
c *           where (hx/hy/hz),(h/k/l) are column matrices             *
c *           hx,hy,hz:  rectangular coordinates in instrument system  *
c *           (phi-axis system)  (in 10**8 cm**-1)                     *
c *          if(icm.ne.0)  cm : u matrix                               *
c *          (hx/hy/hz)=cm*(hx'/hy'/hz')                               *
c *           hx',hy',hz': rectangular coordinates fixed in a crystal  *
c *               (in 10**8 cm**-1)                                    *
c *           where hz' axis is parallel to z-axis                     *
c *                 hy' axis is in y-z plane and normal to hz' axis    *
c *                 hx' axis is normal to hz' and hy' axes             *
c *                                                                    *
c *   (26) ((om(i,j),j=1,3),i=1,3)  (9f8.5)                            *
c *       om: the transformation matrix from instrument system to      *
c *           the system describing the boundary conditions            *
c *                                                                    *
c **********************************************************************
c
c     (27) sig,cs,n1,n2,n3,coef,icont          (4(2a1,3i2,f10.6,1x,a1))
c          give the fourier terms
c          sig: + or -
c          cs: c for cosine and s for sine function
c          n1,n2,n3: the factors for x4,x4,x6
c                  +c 1-2 3 means +cos(x4-2x5+3x6)
c          coef: the factor for the above term
c          icont: give any character except for a blank if the
c              fourier term is followed by the other sine or cosine
c              functions
c     (28) initial parameters and ps  ((12x,6(f9.4,a1)))
c          if dspmdl, tmpmdl and/or sctmdl are zero, the corresponding
c          parameter is not necessary
c
c
c     (29) jx,jb,jp   numbers of independent parameters which are
c          related with constrained amplitudes of the displacement,
c          temperature factor and occupation probability.
c
c          if jx,jb,jp are all zero skip (30)
c***********************************************************************
c*    (30)  j,a,k,ea,cont         (4(3i3,f10.6,a1))                    *
c*          j: atom number                                             *
c*          a: component of vector or tensor (1,2,3 for x,y,z components
c*             of displacement, 1,2,3,4,5,6 for b11,b22,b33,b23,b31,b32*
c*             of inisotropic temperature factor, and 1 for isotropic  *
c*             temperature factor and occupation probability           *
c*          k: fourier term                                            *
c*          ea(j,a,k): coefficient                                     *
c*             the constrained amplitude specified is given by         *
c*             ea(j,a,k)*x where x is the i-th independent valiable.   *
c*             the number i is counted from the blank at the columns   *
c*             of cont.  the blank at the columns of cont means the end*
c*             of constrained variables related to the i-th independent*
c*             variable.  therefore if additional terms are followed   *
c*             then give any character to cont.                        *
c***********************************************************************
c
c                      if itwin=0 skip (31)
c***********************************************************************
c*     (31)    j,ea,cont   (4(i3,6x,f10.6,a1)                          *
c*          j: twin domain number  (1<=j<=6)                           *
c*          ea: volume ratio of twin domains                           *
c***********************************************************************
c
c                  if itwin>=0 or itst=0 skip (32)
c***********************************************************************
c*     (32) j,a,ea,cont (4(2i3,6x,f10.6,a1))                           *
c*          j: twin domain number   (1<=1<=6)                          *
c*          a: component of out-of-step vector (1<=a<=6)               *
c*          ea: factor for out of step                                 *
c*              ea*xpf gives the out of step in the j-th domain        *
c***********************************************************************
c
c     (33) initial values for constrained parameters and
c          twin vol.r, phase flc. scales ext.cor  (8(f9.4,x1))
c
c     (34) iextc
c          iextc: number of blocks
c              extc>1 block diagonal least squars method
c
c     (35) iwf, fct  (if f table necessary, iwf=1 otherwise iwf=0
c             fct: magnification of f in the f table
c
c     (36) maxc,istdv,icont,ifunc,wght 
c          maxc: maximum cycles of the least squars refinement (maxc>=0)
c          istdv: =1 pirnt  standard deviations
c                 =-1 pirnt standard deviations and variant matrix
c                 =0 no standard deviations printed
c          icont: =1 parameters saved in disc are used
c                 =0 parameters specified in data cards are used
c                         time
c          ifunc: =1 sin cos exp functions are used
c                 =0 sin cos exp tables are used to save the computing
c          iwght: =0 given weight is used when fobs>fmin
c                   otherwise wg0 given in (38)
c                 =1 unit weignt is used when fobs>fmin
c                   otherwise wg0
c                =2 100/(fobs)**2  when fobs>fmin
c                   otherwise 100/(fmin)**2
c                =3 fobs/10 when fobs>fmin
c                   otherwise fmin/10
c
c     (37) eps,dmpf,aydm,alp,grad1,expn1,grad2,expn2
c          eps: if r factor difference.lt.mrdf then stop
c          dmpf: damping factor (standard value is about 0.2)
c          aydm: cutoff radius of reflections used in a**-1
c          alph: refinement minimizes modified weighted r-factor with
c               weight factor exp(-alp*(y/2)**2)*w, where y is the
c               reflection vector in the reciprocal space and w is the
c               weight factor specified by wght
c               alp=0: normal weight factor
c          grad1 and expn1: the penalty function,pf1, is defined by
c                      pf1=grad1*(-p)**expn1 for p<0
c                      pf1=grad1*(p-1)**expn1 for p>1
c                      pf1=0 otherwise
c                  standard values grad=1, expn=1
c                 (grad and expn must be positive)
c          grad2 and expn2: the penalty function,pf2, is defined by
c                      pf2=grad2*(dmin-d)**expn for d<dmin
c                      pf2=grad2*(d-dmax)**expn for d>dmax
c                      pf2=0 otherwise
c
c     (38) reflection selection variables ng
c          ng: number of reflection groups
c              =0 all reflections are selected in the refinement
c              >0 give h4 or h4,h5 or h4,h5,h6 (h3+i) specifing
c                 reflection groups to be used in the refinement
c          repeat h3+i ng times
c              reflections transformed from the indices specified
c              above by symmetry operators are used in the refinement
c
c     (39) fmin, wg0 for fobs.lt.fmin, hm
c          fmin,wg0: see (36)
c          hm(1)-hm(6) mean the upper limits of 'miller' indices,
c          default values: hm(1)-hm(3) 24, hm(4)-hm(6) 10
c
c     (40) inp,iorf, format for h1,h2,.. fobs (or iobs) weight(2i2,19a4)
c          if input is cr inp=5, otherwise inp=3, iorf=0,1 iobs and fobs
c
c                        if inp=3  skip (41)
c***********************************************************************
c*    (41) h1,h2.. fobs (or iobs), wght                                *
c*         miller indices fobs (or iobs) weight according to the format*
c*         specified above                                             *
c*                repeat (40) up to the last reflection                *
c*            ****h1=999 mean the end of each data sets****            *
c***********************************************************************
c
c     (42) parameter selection flags                        (80i1)
c          if i-th parameter is refined, give 1 at i-th column
c          otherwise give 0
c   ================  (35)-(42) repeat extc times=================
c
c***************************************************************
c
      include 'premos.inc'
c     parameter (nmax=12000,nhkl=9999,idsmax=2)
      real lenx,leny,hscl,vscl
      complex fc
      real qs
      integer hklm,mpl
      common /chklfm/ hklm(6,nhkl),qs(nhkl),mpl(nhkl),fc(nhkl)
c      common /cbackg/ pb(0:6,idsmax), dpb(6,idsmax), zps(idsmax)
      common /cbackg/ pb(0:12,idsmax), dpb(12,idsmax), zps(idsmax)
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *              fid(idsmax),alpha(idsmax)
      common /criccut/ riccut
      common /ctorms0/ ids
      common /ctorms1/ qmin(idsmax),qmax(idsmax),dq(idsmax),
     *           ndata(idsmax),iwg,iset,mmax(3),wavl(2,idsmax),job
      common /ctorms3/ hwhm(2,idsmax),rhwhm(idsmax),gamma(idsmax),
     * uvw(2,idsmax),sgm(idsmax),p1(idsmax),p2(idsmax),p3(idsmax),
     * p4(idsmax),as(idsmax)
      common /ctorms4/ lenx(idsmax),leny(idsmax),hscl(idsmax),
     *    vscl(idsmax),delta(idsmax),ldev,nrange(idsmax)
      common /crange/ usrmn(20,idsmax),usrmx(20,idsmax)
      character icn
      common /ctorms51/ icn(5,15)
      common /ctorms5/ nlp,ntl(15),il(5,15),cl(5,15)
      common /ctorms6/ cp(0:2,idsmax),pp(0:10,idsmax),pg(idsmax)
      integer ih1(3),ih2(3)
      common /cwflag/ iwflag(7)
      common /cdim/ idm,nde
      common /kwave/ y(3,3,3),vc(3)
      common /extcr/ nextnc,icef(7,48)
      dimension aa(10),bb(10),cc(10),ff(10),cm(3,3),om(3,3)
      common /extcr1/wv,abc0,cm,om,aa,bb,cc,ff,nbf,cef,cbt2,vol
      integer hm
      common /chkln/ iex(6),hm(6)
      integer hd1,hd2
      common /cpref/ hd1(6,48),hd2(6,48),iequ1,iequ2,pop,itype1,itype2
c      common /cpref/ hd1(3),hd2(3),pop,itype1,itype2
      real wl(9),wl1(9),wl2(9)
      character*80 flnm0
      common /ctorms7 /flnm0(idsmax)
      character*2 wxr(9),xray(idsmax)
      character*5 lgrp(12),lgr
      data wl/0.7107,1.4364,1.5418,1.6591,1.7902,1.9373,2.2909,2*0.0/
      data wl1/0.709300,1.435155,1.540562,1.657910,1.788965,1.936042,
     *         2.289700,2*0.0/
      data wl2/0.713590,1.439000,1.544390,1.661747,1.792850,1.939980,
     *         2.293606,2*0.0/
      data wxr/'mo','zn','cu','ni','co','fe','cr','tn','tf'/
      data lgrp/'m3m','m3','4/mmm','4/m','mmm','2/m','-1',
     *           '6/mmm','6/m','-3m1','-31m','-31'/
      data pi/3.141592/

c      call set_divide_by_zero
c     call set_arithmetic_underflow
c      call set_arithmetic_overflow
      fact=pi/180
      iwflag(3)=1
      call setinp(5)
      call setout(6)
c      read(5,*) job,ids
      call freadi('job=',1,job,1)
      call freadi('ids=',1,ids,0)
      write(6,*) 'job=',job,' ids=',ids
      call setnfil(ids)
c      read(5,'(a)') lgr,iset
      call freadc('lgr=',1,lgr,1)
      if(lgr.eq.'2/m') then
          call freadi('iset=',1,iset,0)
          write(6,*) 'lgr=',lgr,'iset=',iset
      else
          write(6,*) 'lgr=',lgr
      end if
      iwg=0
      do 110 i=1,12
      if(lgr.eq.lgrp(i)) then
          iwg=i
      end if
 110  continue
      if(iwg.eq.0) call quit('invalid laue group')
c      read(5,*) mmax(1),mmax(2),mmax(3),riccut
      call freadi('mmax=',3,mmax,1)
      call freadr('riccut=',1,riccut,0)
      if(riccut.eq.0.) riccut=0.001
      write(6,*) 'mmax=',mmax(1),mmax(2),mmax(3),' riccut=',riccut
c      read(5,*) isype,ih1,ih2
      call freadi('ih1=',3,ih1,1)
      call freadi('ih2=',3,ih2,0)
      call freadi('itype1=',1,itype1,0)
      call freadi('itype2=',1,itype2,0)
      write(6,*)  'ih1=',ih1,' ih2=',ih2,' itype1=',itype1,
     *                                   ' itype2=',itype2
      hd1(1,1)=ih1(1)
      hd1(2,1)=ih1(2)
      hd1(3,1)=ih1(3)
      hd1(4,1)=0
      hd1(5,1)=0
      hd1(6,1)=0
      hd2(1,1)=ih2(1)
      hd2(2,1)=ih2(2)
      hd2(3,1)=ih2(3)
      hd2(4,1)=0
      hd2(5,1)=0
      hd2(6,1)=0
c      read(5,*) ldev
      call freadi('ldev=',1,ldev,1)
      write(6,*) 'ldev=',ldev
c*******************************************************************
      do 500 id=1,ids
c      read(5,'(a)') xray
      call freadc('xray=',1,xray(id),1)
      call freadi('backgr=',1,ibkgr,0)
      write(6,*) 'xray=',xray(id),' backgr=',ibkgr
c     read(5,*) wavl(1,id)
c      if(xray(id).eq.'tn') then
c         call freadr('wavl=',1,wavl(1,id),1)
c         write(6,*) 'wavl=',wavl(1,id)
c      end if
      call setbgr(id,ibkgr)
c      read(5,*) qmin,qmax,qint,nrange,ixax,ilp
      call freadr('qmin=',1,qmin(id),1)
      call freadr('qmax=',1,qmax(id),0)
      call freadr('qint=',1,qint,0)
      call freadi('nrange=',1,nrange(id),0)
      call freadi('ixax=',1,ixax(id),0)
      call freadi('ilp=',1,ilp(id),0)
      if(ilp(id).eq.3) then
         call freadr('alpha=',1,alpha(id),0)
      end if
      if(nrange(id).gt.20) call quit('nrange > 20')
      if(ixax(id).ne.0.and.ixax(id).ne.1) then
           call quit('ixax should be 0 or 1')
      end if
      if(ilp(id).ne.0.and.ilp(id).ne.1.and.ilp(id).ne.-1.and.
     *   ilp(id).ne.2.and.ilp(id).ne.3.and.ilp(id).ne.4) then
           call quit('ilp should be 0, 1, -1, 2, 3 or 4')
      end if
      if(xray(id).eq.'tf'.and.ixax(id).eq.1) then
           call quit('ixax should be 0')
      end if
      dq(id)=qint
      if(ilp(id).ne.3) then
         write(6,*) 'qmin=',qmin(id),' qmax=',qmax(id),' qint=',qint,
     *         ' nrange=',nrange(id),' ixax=',ixax(id), ' ilp=',ilp(id)
      else
         write(6,*) 'qmin=',qmin(id),' qmax=',qmax(id),' qint=',qint,
     *       ' nrange=',nrange(id),' ixax=',ixax(id), ' ilp=',ilp(id),
     *       ' alpha=',alpha(id)
      end if
      iwl(id)=0
      do 100 i=1,9
          if(xray(id).eq.wxr(i)) then
              iwl(id)=i
              if(ilp(id).eq.2) then
                  wavl(1,id)=wl1(iwl(id))
                  wavl(2,id)=wavl(1,id)
              else
                  wavl(1,id)=wl1(iwl(id))
                  wavl(2,id)=wl2(iwl(id))
              end if
              if(i.le.7) then
                  write(6,*) 'wavl=',wavl(1,id),wavl(2,id)
              else if(i.eq.8) then
                 call freadr('wavl=',1,wavl(1,id),1)
                 write(6,*) 'wavl=',wavl(1,id)
                 wavl(2,id)=wavl(1,id)
              else if(i.eq.9) then
                  wavl(1,id)=wl1(3)
                  wavl(2,id)=wl2(3)
              end if
          end if
 100  continue
      if(iwl(id).eq.0) call quit('invalid xray source')
c      read(5,*) (usrmn(i),usrmx(i),i=1,nrange)
      do 111 i=1,nrange(id)
          call freadr('usrmn=',1,usrmn(i,id),1)
          call freadr('usrmx=',1,usrmx(i,id),0)
 111  continue
      if(nrange(id).eq.0) then
          usrmn(1,id)=qmin(id)
          usrmx(1,id)=qmax(id)
          nrange(id)=1
      else
          do 65 i=1,nrange(id)
             if(usrmn(i,id).le.qmin(id)) then
                  usrmn(i,id)=qmin(id)
             end if
             if(usrmx(i,id).gt.qmax(id).or.usrmx(i,id).eq.0.) then
                  usrmx(i,id)=qmax(id)
             end if
 65       continue
      end if
      write(6,*) 'usrmn,usrmx', (usrmn(i,id),usrmx(i,id),i=1,nrange(id))
c      if(iwl(id).le.8.or.job.eq.1) then
      if(iwl(id).le.7.or.job.eq.1) then
           ndata(id)=(qmax(id)-qmin(id))/qint+1.001
           if(ndata(id).gt.nmax) call quit('ndata>nmax')
      end if
c      read(5,*) thbm,fi
      call freadr('thbm=',1,thbmd(id),1)
      if(ilp(id).eq.2) then
          call freadr('fi=',1,fid(id),0)
      end if
      if(ilp(id).lt.2) then
          write(6,*) 'thbm=',thbmd(id)
      else
          write(6,*) 'thbm=',thbmd(id),' fi=',fid(id)
      end if
c      thbm, fi in radian
      thbmd(id)=thbmd(id)*fact
      fid(id)=fid(id)*fact
c      read(5,*) lenx,leny,vscl,delta
      call freadr('lenx=',1,lenx(id),1)
      call freadr('leny=',1,leny(id),0)
      call freadr('vscl=',1,vscl(id),0)
      call freadr('delta=',1,delta(id),0)
      write(6,*) 'lenx=',lenx(id),' leny=',leny(id),
     *   ' vscl=',vscl(id),' delta=',delta(id)
      hscl(id)=1
c      read(5,*) (pb(j),j=0,6)
c      call freadr('pb=',7,pb(0,id),1)
      call freadr('pb=',13,pb(0,id),1)
      if(xray(id).ne.'tf') then
c          read(5,*) as(id)
          call freadr('as=',1,as(id),1)
c          read(5,*) uvw
          call freadr('uv=',2,uvw(1,id),1)
c          read(5,*) gamma(id)
          call freadr('gamma=',1,gamma(id),1)
c          read(5,*) hwhm(id)
          call freadr('hwhm=',2,hwhm(1,id),1)
          call freadr('rhwhm=',1,rhwhm(id),1)
      else
          call freadr('si=',6,pp(0,id),1)
          call freadr('gi=',3,pp(6,id),1)
          call freadr('ri=',2,pp(9,id),1)
          call freadr('rs1=',1,rhwhm(id),1)
      end if
      call freadr('sgm=',1,sgm(id),1)
c      read(5,*) pg(id)
      call freadr('pg=',1,pg(id),1)
c      read(5,*) p1,p2,p3,p4
      call freadr('p1=',1,p1(id),1)
      call freadr('p2=',1,p2(id),0)
      call freadr('p3=',1,p3(id),0)
      call freadr('p4=',1,p4(id),0)
      if(xray(id).ne.'tf') then
c          read(5,*) zps(id)
          call freadr('zps=',1,zps(id),1)
c          write(6,*) 'pb=',(pb(j,id),j=0,6),' as=',as(id),
          write(6,*) 'pb=',(pb(j,id),j=0,12),' as=',as(id),
     *          ' uv=',(uvw(j,id),j=1,2)
          write(6,*) 'gamma=',gamma(id),' hwhm=',(hwhm(j,id),j=1,2)
          write(6,*) 'rhwhn=',rhwhm(id),' sgm=',sgm(id)
          write(6,*) 'p1=',p1(id),' p2=',p2(id),
     *              ' p3=',p3(id),' p4=',p4(id),' zps=',zps(id)
      else
          call freadr('c0=',1,cp(0,id),1)
          call freadr('c1=',1,cp(1,id),0)
          call freadr('c2=',1,cp(2,id),0)
c          write(6,*) 'pb=',(pb(j,id),j=0,6)
          write(6,*) 'pb=',(pb(j,id),j=0,12)
          write(6,*) 'pp=',(pp(j,id),j=0,10)
          write(6,*) 'rs1=',rhwhm(id),' sgm=',sgm(id)
          write(6,*) 'pg=',pg(id)
          write(6,*) 'p1=',p1(id),' p2=',p2(id),
     *              ' p3=',p3(id),' p4=',p4(id)
          write(6,*) 'cp=',(cp(j,id),j=0,2)
      end if
 500  continue
*****************************************************************
c      read(5,*) nlp
      call freadi('nlp=',1,nlp,1)
      write(6,*) 'nlp=',nlp
      do 120 i=1,nlp
      read(5,'(5(i2,f9.4,a1))') (il(j,i),cl(j,i),icn(j,i),j=1,5)
      do 50 j=1,5
      if(icn(j,i).eq.' ') then
            ntl(i)=j
            go to 60
      end if
 50   continue
 60   continue
      write(6,'(5(i2,f9.4,a1))') (il(j,i),cl(j,i),icn(j,i),j=1,ntl(i))
 120  continue
      do 510 id=1,ids
          read(5,'(a)') flnm0(id)
          lfn0=istrln(flnm0(id))
          write(6,'(1h ,a)') flnm0(id)(1:lfn0)
 510  continue
c*************************************
             call remos
c*************************************
      if(ldev.eq.1.or.ldev.eq.2) then
          call getzap()
      end if
      call quit(' ')
      stop
      end

      subroutine quit(str)
      character*(*) str
      real tarray(2)
      write(6,*) str
      close(unit=3)
      close(unit=4)
      close(unit=91)
      close(unit=92)
c      time=etime(tarray)
c      write(6,*) '******elapsed time=',time,'sec******'
      stop
      end

      subroutine gethkl(n,id)
      include 'premos.inc'
c     parameter (nhkl=9999,idsmax=2)
      complex fc
      real qs
      integer hklm,mpl
      common /chklfm/ hklm(6,nhkl),qs(nhkl),mpl(nhkl),fc(nhkl)
      integer hklmd(6,nhkl*3)
      common /ciwl/ iwl(idsmax),ixax(idsmax),ilp(idsmax),thbmd(idsmax),
     *              fid(idsmax),alpha(idsmax)
      common /ctorms0/ ids
      common /ctorms1/ qmin(idsmax),qmax(idsmax),dq(idsmax),
     *           ndata(idsmax),iwg,iset,mmax(3),wavl(2,idsmax),job
      real qk(nhkl),q(3)
      integer ns,st
      common /cqsort/ ns(nhkl),st(nhkl,2)
      integer hmax,kmax,lmax
      integer ih(6),h1,h2,h3,h4,h5,h6
      common /cdim/ idm,nde
      common /kwave/ y(3,3,3),vc(3)
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
c     character*80 fmt
c     common /cfmt/ fmin,wg0,inp,iorf,fmt
      character*80 fmt
      common /cfmt/ fmt
      common /cfmin/ fmin,wg0,inp,iorf
      data pi/3.141592/, eps/0.00001/
      fact=pi/180
      n=0
c      write(6,*) 'qmin=',qmin(id),' wavl=',wavl(2,id)  !******************8
      if(iwl(id).le.7) then
           qmnd=2*sin(fact*qmin(id)/2)/wavl(2,id)
           qmxd=2*sin(fact*qmax(id)/2)/wavl(1,id)
      else if(iwl(id).eq.8) then
c          if(ixax(id).eq.1) then
              qmnd=2*sin(fact*qmin(id)/2)/wavl(2,id)
              qmxd=2*sin(fact*qmax(id)/2)/wavl(1,id)
c          else
c              qmnd=qmin(id)/(pi*2)
c              qmxd=qmax(id)/(pi*2)
c          end if
      else if(iwl(id).eq.9) then
           qmnd=qmin(id)/(pi*2)
           qmxd=qmax(id)/(pi*2)
      end if
      eps=0.01
      qmn=max(0.,qmnd-eps)
      qmx=qmxd+eps
c       generate hkl in each substructure
      do 500 jd=1,nsub
c     get hmax,kmax,lmax from qmx
      call mhklm(qmx,hmax,kmax,lmax,y,mmax,jd)
      if(iwg.eq.1) then
c      laue group m3m
            do 100 h1=0,hmax
            do 100 h2=0,h1
            do 100 h3=0,h2
            do 100 h4=-mmax(1),mmax(1)
            do 100 h5=-mmax(2),mmax(2)
            do 100 h6=-mmax(3),mmax(3)
            call getih(ih,h1,h2,h3,h4,h5,h6,jd)
            call getq(ih,q)
            if(q(2).gt.q(1).or.q(3).gt.q(2)) go to 100
            if(q(1).lt.0.or.q(2).lt.0.or.q(3).lt.0) go to 100
c           if(isaveh(ih,hklm,qmn,qmx,mpl,qk,n).eq.1) then
            if(isaveh(ih,hklmd,qmn,qmx,n).eq.1) then
                  go to 999
            end if
 100        continue
      else if(iwg.eq.2) then
c      laue group m3
            do 110 h1=0,hmax
            do 110 h2=0,hmax
            do 110 h3=0,hmax
            do 110 h4=-mmax(1),mmax(1)
            do 110 h5=-mmax(2),mmax(2)
            do 110 h6=-mmax(3),mmax(3)
            call getih(ih,h1,h2,h3,h4,h5,h6,jd)
            call getq(ih,q)
c           if(q(2).gt.q(1).or.q(3).gt.q(1)) go to 110
            if(abs(q(1)-q(2)).gt.eps.or.abs(q(2)-q(3)).gt.eps.or.
     *           abs(q(1)-q(3)).gt.eps) then
               if(q(2)-q(3).lt.0.or.q(1)-q(3).le.0) go to 110
            end if
            if(q(1).lt.0.or.q(2).lt.0.or.q(3).lt.0) go to 110
c           if(isaveh(ih,hklm,qmn,qmx,mpl,qk,n).eq.1) then
            if(isaveh(ih,hklmd,qmn,qmx,n).eq.1) then
                  go to 999
            end if
 110        continue
      else if(iwg.eq.3) then
c      laue group 4/mmm
            do 120 h1=0,hmax
            do 120 h2=0,h1
            do 120 h3=0,lmax
            do 120 h4=-mmax(1),mmax(1)
            do 120 h5=-mmax(2),mmax(2)
            do 120 h6=-mmax(3),mmax(3)
            call getih(ih,h1,h2,h3,h4,h5,h6,jd)
            call getq(ih,q)
            if(q(2).gt.q(1)) go to 120
            if(q(3).lt.0) go to 120
c           if(isaveh(ih,hklm,qmn,qmx,mpl,qk,n).eq.1) then
            if(isaveh(ih,hklmd,qmn,qmx,n).eq.1) then
                  go to 999
            end if
 120        continue
      else if(iwg.eq.4) then
c      laue group 4/m
            do 130 h1=0,hmax
            do 130 h2=0,hmax
            do 130 h3=0,lmax
            do 130 h4=-mmax(1),mmax(1)
            do 130 h5=-mmax(2),mmax(2)
            do 130 h6=-mmax(3),mmax(3)
            call getih(ih,h1,h2,h3,h4,h5,h6,jd)
            call getq(ih,q)
            if(q(3).lt.0) go to 130
            if(q(1).eq.0.and.q(2).gt.0) go to 130
c           if(isaveh(ih,hklm,qmn,qmx,mpl,qk,n).eq.1) then
            if(isaveh(ih,hklmd,qmn,qmx,n).eq.1) then
                  go to 999
            end if
 130        continue
      else if(iwg.eq.5) then
c      laue group mmm
            do 140 h1=0,hmax
            do 140 h2=0,kmax
            do 140 h3=0,lmax
            do 140 h4=-mmax(1),mmax(1)
            do 140 h5=-mmax(2),mmax(2)
            do 140 h6=-mmax(3),mmax(3)
            call getih(ih,h1,h2,h3,h4,h5,h6,jd)
            call getq(ih,q)
            if(q(1).lt.0.or.q(2).lt.0.or.q(3).lt.0) go to 140
c           if(isaveh(ih,hklm,qmn,qmx,mpl,qk,n).eq.1) then
            if(isaveh(ih,hklmd,qmn,qmx,n).eq.1) then
                  go to 999
            end if
 140        continue
      else if(iwg.eq.6.and.iset.eq.1) then
c      laue group 2/m
c           c : unique axis
            do 151 h1=-hmax,hmax
            do 151 h2=0,kmax
            do 151 h3=0,lmax
            do 151 h4=-mmax(1),mmax(1)
            do 151 h5=-mmax(2),mmax(2)
            do 151 h6=-mmax(3),mmax(3)
            call getih(ih,h1,h2,h3,h4,h5,h6,jd)
            call getq(ih,q)
            if(q(2).lt.0.or.q(3).lt.0) go to 151
            if(q(2).eq.0.and.q(1).lt.0) go to 151
c           if(isaveh(ih,hklm,qmn,qmx,mpl,qk,n).eq.1) then
            if(isaveh(ih,hklmd,qmn,qmx,n).eq.1) then
                  go to 999
            end if
 151        continue
      else if(iwg.eq.6.and.iset.eq.2) then
c      laue group 2/m
c           b : unique axis
            do 150 h1=-hmax,hmax
            do 150 h2=0,kmax
            do 150 h3=0,lmax
            do 150 h4=-mmax(1),mmax(1)
            do 150 h5=-mmax(2),mmax(2)
            do 150 h6=-mmax(3),mmax(3)
            call getih(ih,h1,h2,h3,h4,h5,h6,jd)
            call getq(ih,q)
            if(q(2).lt.0.or.q(3).lt.0) go to 150
            if(q(3).eq.0.and.q(1).lt.0) go to 150
c           if(isaveh(ih,hklm,qmn,qmx,mpl,qk,n).eq.1) then
            if(isaveh(ih,hklmd,qmn,qmx,n).eq.1) then
                  go to 999
            end if
 150        continue
      else if(iwg.eq.6.and.iset.eq.3) then
c      laue group 2/m
c           a: unique axis
            do 152 h2=-kmax,kmax
            do 152 h1=0,hmax
            do 152 h3=0,lmax
            do 152 h4=-mmax(1),mmax(1)
            do 152 h5=-mmax(2),mmax(2)
            do 152 h6=-mmax(3),mmax(3)
            call getih(ih,h1,h2,h3,h4,h5,h6,jd)
            call getq(ih,q)
            if(q(1).lt.0.or.q(3).lt.0) go to 152
            if(q(3).eq.0.and.q(2).lt.0) go to 152
c           if(isaveh(ih,hklm,qmn,qmx,mpl,qk,n).eq.1) then
            if(isaveh(ih,hklmd,qmn,qmx,n).eq.1) then
                  go to 999
            end if
 152        continue
      else if(iwg.eq.7) then
c      laue group -1
            do 160 h1=-hmax,hmax
            do 160 h2=-kmax,kmax
            do 160 h3=0,lmax
            do 160 h4=-mmax(1),mmax(1)
            do 160 h5=-mmax(2),mmax(2)
            do 160 h6=-mmax(3),mmax(3)
            call getih(ih,h1,h2,h3,h4,h5,h6,jd)
            call getq(ih,q)
            if(q(3).lt.0) go to 160
            if(q(1).eq.0.and.q(2).lt.0) go to 160
c            if(q(2).eq.0.and.q(1).lt.0) go to 160
c           if(isaveh(ih,hklm,qmn,qmx,mpl,qk,n).eq.1) then
            if(isaveh(ih,hklmd,qmn,qmx,n).eq.1) then
                  go to 999
            end if
 160        continue
      else if(iwg.eq.8) then
c      laue group 6/mmm
            do 170 h1=0,hmax
            km=min(h1,hmax-h1)
            do 170 h2=0,km
            do 170 h3=0,lmax
            do 170 h4=-mmax(1),mmax(1)
            do 170 h5=-mmax(2),mmax(2)
            do 170 h6=-mmax(3),mmax(3)
            call getih(ih,h1,h2,h3,h4,h5,h6,jd)
            call getq(ih,q)
            if(q(2).gt.q(1)) go to 170
            if(q(1).lt.0.or.q(2).lt.0.or.q(3).lt.0) go to 170
c           if(isaveh(ih,hklm,qmn,qmx,mpl,qk,n).eq.1) then
            if(isaveh(ih,hklmd,qmn,qmx,n).eq.1) then
                  go to 999
            end if
 170        continue
      else if(iwg.eq.9) then
c      laue group 6/m
            do 180 h1=0,hmax
            do 180 h2=0,hmax-h1
            do 180 h3=0,lmax
            do 180 h4=-mmax(1),mmax(1)
            do 180 h5=-mmax(2),mmax(2)
            do 180 h6=-mmax(3),mmax(3)
            call getih(ih,h1,h2,h3,h4,h5,h6,jd)
            call getq(ih,q)
            if(q(3).lt.0) go to 180
            if(q(1).lt.0.or.q(2).lt.0) go to 180
            if(q(1).eq.0.and.q(2).gt.0) go to 180
c           if(isaveh(ih,hklm,qmn,qmx,mpl,qk,n).eq.1) then
            if(isaveh(ih,hklmd,qmn,qmx,n).eq.1) then
                  go to 999
            end if
 180        continue
      else if(iwg.eq.10) then
c      laue group -3m1
            do 185 h1=0,hmax
c            km=min(h1,hmax-h1)
            do 185 h2=0,hmax-h1
            do 185 h3=0,lmax
            do 185 h4=-mmax(1),mmax(1)
            do 185 h5=-mmax(2),mmax(2)
            do 185 h6=-mmax(3),mmax(3)
            call getih(ih,h1,h2,h3,h4,h5,h6,jd)
            call getq(ih,q)
            if(q(3).lt.0) go to 185
            if(q(1).lt.0) go to 185
            if(q(2).lt.0) go to 185
c            if(q(1).eq.0.and.q(2).gt.0) go to 185
            if(q(3).eq.0.and.q(2).gt.q(1)) go to 185
c           if(isaveh(ih,hklm,qmn,qmx,mpl,qk,n).eq.1) then
            if(isaveh(ih,hklmd,qmn,qmx,n).eq.1) then
                  go to 999
            end if
 185        continue
      else if(iwg.eq.11) then
c      laue group -31m
            do 186 h1=0,hmax
            km=min(h1,hmax-h1)
            ks=-km/2
            do 186 h2=ks,km
            do 186 h3=0,lmax
            do 186 h4=-mmax(1),mmax(1)
            do 186 h5=-mmax(2),mmax(2)
            do 186 h6=-mmax(3),mmax(3)
            call getih(ih,h1,h2,h3,h4,h5,h6,jd)
            call getq(ih,q)
            if(q(3).lt.0) go to 186
            if(q(2).gt.q(1)) go to 186
            if(q(2).lt.-q(1)/2) go to 186
            if(q(1).ne.0.and.q(2).ne.0.and.abs(q(1)/2+q(2)).lt.eps)
     *           go to 186
c           if(isaveh(ih,hklm,qmn,qmx,mpl,qk,n).eq.1) then
            if(isaveh(ih,hklmd,qmn,qmx,n).eq.1) then
                  go to 999
            end if
 186        continue
      else if(iwg.eq.12) then
c      laue group -3
            do 190 h1=0,hmax
            do 190 h2=0,hmax-h1
            do 190 h3=-lmax,lmax
            do 190 h4=-mmax(1),mmax(1)
            do 190 h5=-mmax(2),mmax(2)
            do 190 h6=-mmax(3),mmax(3)
            call getih(ih,h1,h2,h3,h4,h5,h6,jd)
            call getq(ih,q)
            if(q(1).lt.0) go to 190
            if(q(2).lt.0) go to 190
            if(q(1).eq.0.and.q(2).gt.0) go to 190
c           if(isaveh(ih,hklm,qmn,qmx,mpl,qk,n).eq.1) then
            if(isaveh(ih,hklmd,qmn,qmx,n).eq.1) then
                  go to 999
            end if
 190        continue
      end if
 999  continue
 500  continue
c     write(6,*) 'generated reflections=',n
c     remove overlaped reflections
      call removh(hklmd,hklm,mpl,qk,n)
      write(6,*) 'generated reflections=',n
c     write(6,*) 'independent reflections=',n
c      call qsort(qk,st,ns,n)
      rewind 3
      do 131 ii=1,n
c      i=ns(ii) 
      i=ii
      write(3,fmt) (hklm(j,i),j=1,idm),mpl(i)
 131  continue
      iend=999
      write(3,'(i3)') iend
      return
      end

      subroutine removh(hklmd,hklm,mpl,qk,n)
      integer hklmd(6,*),hklm(6,*),mpl(*)
      real qk(*)
      include 'premos.inc'      
c     parameter (nhkl=9999)
      real qd(nhkl*3),qe(3,nhkl*3)
      integer imrk(nhkl*3),hequiv
      integer hs(6,48)
      integer ns(nhkl*3),st(nhkl*3,2)
      data eps/0.0001/
      if(n.gt.nhkl*3) call quit('n > nhkl*3')
      do 100 i=1,n
c         qd(i)=qk(i)
          qd(i)=getqk(hklmd(1,i))
          imrk(i)=0
          call getq(hklmd(1,i),qe(1,i))
c         write(6,*) 'qk=',qd(i),'hklmd=',(hklmd(j,i),j=1,3)
 100  continue
      call qsort(qd,st,ns,n)
c     remove overlapped reflections
      do 200 id=1,n
          i=ns(id)
          if(imrk(i).eq.1) go to 200
          do 210 jd=id+1,n
              j=ns(jd)
c             if(qd(jd).gt.qd(id)+eps.or.imrk(j).eq.1) go to 200
              if(qd(jd).gt.qd(id)+eps) go to 200
              if(imrk(j).eq.1) go to 210
              if(hequiv(qe(1,i),qe(1,j)).eq.1) then
                  imrk(j)=1
              end if
 210      continue
 200  continue
c       pack hklm, qk, mpl
      m=0
      do 300 i=1,n
          if(imrk(i).eq.0) then
              m=m+1
              if(m.gt.nhkl) then
                  write(6,*) 'nhkl=',nhkl
                  call quit('number of generated reflections > nhkl')
              end if
              call vicpy(hklmd(1,i),hklm(1,m),6)
c             qk(m)=qk(i)
c             mpl(m)=mpl(i)
              qk(m)=getqk(hklmd(1,i))
              mpl(m)=multpl(hklmd(1,i),hs)
          end if
 300  continue
      n=m
      return
      end

      integer function hequiv(h1,h2)
      real h1(*),h2(*)
      data eps/0.00001/
      hequiv=0
      do 100 i=1,3
          if(abs(h1(i)-h2(i)).gt.eps) return
 100  continue
      hequiv=1
      return
      end

      subroutine vicpy(a,b,n)
      integer a(*),b(*)
      integer n
      do 100 i=1,n
      b(i)=a(i)
 100  continue
      return
      end

      subroutine vircpy(a,b,n)
      integer a(*)
      real b(*)
      integer n
      do 100 i=1,n
      b(i)=a(i)
 100  continue
      return
      end

c     function isaveh(ih,hklm,qmn,qmx,mpl,qks,n)
      function isaveh(ih,hklm,qmn,qmx,n)
      common /cdim/ idm,nde
      include 'premos.inc'
c     parameter (nhkl=9999)
c     integer ih(*),hklm(6,*),mpl(*)
      integer ih(*),hklm(6,*)
c     real qks(*),hh(3)
c      integer hs(6,48)
      isaveh=0
      if(ih(1).eq.0.and.ih(2).eq.0.and.ih(3).eq.0.and.
     *   ih(4).eq.0.and.ih(5).eq.0.and.ih(6).eq.0) return
      qk=getqk(ih)
      if(qk.lt.qmn.or.qk.gt.qmx) return
c     remove reflections violating extinction rules for general reflections
      if(irefcd(ih).eq.0) return
      n=n+1
      do 101 i=1,idm
      hklm(i,n)=ih(i)
 101  continue
      do 102 i=idm+1,6
      hklm(i,n)=0
 102  continue
c     mpl(n)=multpl(hklm(1,n),hs)
c     qks(n)=qk
      if(n.gt.nhkl*3) then
            call quit('***n > nhkl***')
      end if
      return
      end

      function getqk(ih)
      integer ih(*)
      real hh(3)
c     common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3),gabn(3,3)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      common /cdim/ idm,nde
      common /kwave/ y(3,3,3),vc(3)
      do 11 j=1,3
      hh(j)=ih(j)
          do 12 i=1,nde
 12       hh(j)=hh(j)+y(j,i,1)*ih(i+3)
 11   continue
      getqk=vabs1(hh,3,gabn(1,1,1))
      return
      end

      integer function multpl(h,hs)
      integer h(*),hr(6),hs(6,*)
      integer rr
c      common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      common /cdim/ idm,nde
      mul=0
      do 100 ns=1,nsymo
      do 100 j=0,1
           call gethr(h,hr,rr(1,1,1,1),ns)
           if(j.eq.1) then
                do 202 k=1,idm
                hr(k)=-hr(k)
 202            continue
           end if
           do 200 k=1,mul
           if(icomp(hr,hs(1,k)).eq.1) then
                go to 100
           end if
 200       continue
           mul=mul+1
           do 201 k=1,idm
                hs(k,mul)=hr(k)
 201       continue
 100  continue
      multpl=mul
      return
      end

      integer function icomp(h,hr)
      integer h(*),hr(*)
      common /cdim/ idm,nde
      icomp=0
      do 100 i=1,idm
           if(h(i).ne.hr(i)) return
 100  continue
      icomp=1
      return
      end

      function irefcd(ih)
      integer ih(*)
c      common /extcr/ nextnc,icef(7,48)
      common /cctr/ ctr(6,0:48),nctr
      common /cdim/ idm,nde
      integer rr
c      common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      integer hr(6)
      complex extf,cexpf
      data pi2/6.28318/, eps/0.0001/
c     remove reflections violating extinction rules 
c        due to bravais type
      irefcd=0
      extf=(0.,0.)
      do 10 i=0,nctr
      arg=0
           do 11 j=1,idm
 11        arg=arg+ctr(j,i)*ih(j)
c     extf=extf+cexp(pi2*(0.,1.)*arg)
      extf=extf+cexpf(pi2*(0.,1.)*arg)
 10   continue
      extf=extf/(nctr+1)
      if(abs(extf).lt.eps) return
c     remove reflections violating extinction rules due to screw and glide
      extf=(0.,0.)
      nn=0
      do 20 ic=0,icent
      do 20 ns=1,nsymo
          call gethr(ih,hr,rr(1,1,1,1),ns)
          if(ic.eq.1) then
              do 25 i=1,idm
 25           hr(i)=-hr(i)
          end if
          if(icomp(ih,hr).ne.1) go to 20
c         symmetry operator leaving diffraction vector invariant
          xx=0
          if(ic.eq.0) then
              do 30 i=1,idm
 30           xx=xx+ih(i)*tt(i,ns,1)
          else
              do 31 i=1,idm
 31           xx=xx-ih(i)*tt(i,ns,1)
          end if
c          extf=extf+cexp(pi2*(0.,1.)*xx)
          extf=extf+cexpf(pi2*(0.,1.)*xx)
          nn=nn+1
 20   continue
c         factor of structure factor
      extf=extf/nn
      if(abs(extf).le.eps) return
      irefcd=1
      return
      end

      subroutine getih(ih,h1,h2,h3,h4,h5,h6,isub)
      integer ih(*),h1,h2,h3,h4,h5,h6
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      i1=zmtrx(1,isub)
      i2=zmtrx(2,isub)
      i3=zmtrx(3,isub)
      i4=zmtrx(4,isub)
      i5=zmtrx(5,isub)
      i6=zmtrx(6,isub)
      ih(i1)=h1
      ih(i2)=h2
      ih(i3)=h3
      ih(i4)=h4
      ih(i5)=h5
      ih(i6)=h6
c      write(6,'(6i4)') (ih(i),i=1,6)
      return
      end

      subroutine getq(ih,q)
      real q(*)
      integer ih(*)
      common /kwave/ y(3,3,3),vc(3)
      common /cdim/ idm,nde
      do 10 i=1,3
      q(i)=ih(i)
          do 20 j=1,nde
          q(i)=q(i)+y(i,j,1)*ih(j+3)
 20       continue
 10   continue
      return
      end

      subroutine vtbar(x,y,dy)
c     x,y,dy: x,y coordinates and length of vertical var in cm
      call plot(x,y-dy/2,3)      
      call plot(x,y+dy/2,2)      
      return
      end

      subroutine mhklm(qmx,hmax,kmax,lmax,y,mmax,i)
      real y(3,3,*)
      integer mmax(*)
c     qmax: maximum value of diffraction vector in angstrome
      integer hmax,kmax,lmax
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      data pi/3.141592/
      fact=pi/180
      an1=sqrt(gab(1,1,i))
      an2=sqrt(gab(2,2,i))
      an3=sqrt(gab(3,3,i))
      m1=mmax(1)
      m2=mmax(2)
      m3=mmax(3)
c     qmax*a=hmax-abs(m1*y(1,1,i))-abs(m2*y(1,2,i))-abs(m3*y(1,3,i))
c     qmax*b=kmax-abs(m1*y(2,1,i))-abs(m2*y(2,2,i))-abs(m3*y(2,3,i))
c     qmax*c=lmax-abs(m1*y(3,1,i))-abs(m2*y(3,2,i))-abs(m3*y(3,3,i))
      hmax=qmx*an1+1+abs(m1*y(1,1,i))+abs(m2*y(1,2,i))+abs(m3*y(1,3,i))
      kmax=qmx*an2+1+abs(m1*y(2,1,i))+abs(m2*y(2,2,i))+abs(m3*y(2,3,i))
      lmax=qmx*an3+1+abs(m1*y(3,1,i))+abs(m2*y(3,2,i))+abs(m3*y(3,3,i))
      write(6,*) 'hmax=',hmax,' kmax=',kmax,' lmax=',lmax
      return
      end

c      subroutine rdrefc
c      common /cdim/ idm,nde
c      common /extcr/ nextnc,icef(7,48)
c      common /cwflag/ iwflag(7)
c      if(iwflag(3).eq.1) then
c           write(6,*) 'extinction rules'
c      end if
c      do 90 i=1,nextnc
cc      read(5,*) (icef(j,i),j=1,idm),nmod(i)
c      call freadi('mi=',idm+1,icef(1,i),1)
c      if(iwflag(3).eq.1) then
c           write(6,*) (icef(j,i),j=1,idm+1)
c      end if
c 90   continue
c      return
c      end

      complex function cexpf(z)
      complex z,i
      data i/(0., 1.)/
      x=aimag(z)
      cexpf=cos(x)+i*sin(x)
      return
      end

      subroutine setbgr(id,ibkgr)
      include 'premos.inc'
c     parameter (idsmax=2)
c      include 'idsmax.inc'
      common /cbackgr/ ibackgr(idsmax)
      ibackgr(id)=ibkgr
      return
      end

      subroutine getbgr(id,ibkgr)
      include 'premos.inc'
c      parameter (idsmax=2)
c      include 'idsmax.inc'
      common /cbackgr/ ibackgr(idsmax)
      ibkgr=ibackgr(id)
      return
      end

      subroutine qsort(x,st,ip,nx)
c     quick sort (ascending order of x)
c     nx: the number of data x
c     ip: the initial order
c     st: a work array
      real x(nx)
      integer r,s,st(nx,0:1),ip(nx)
      do 10 i=1,nx
 10   ip(i)=i
      s=1
      st(1,0)=1
      st(1,1)=nx
    1 l=st(s,0)
      r=st(s,1)
      s=s-1
    2 i=l
      j=r
      xt=x((l+r)/2)
    3 if(i.lt.nx) then
         if(x(i).lt.xt) then
            i=i+1
            go to 3
         endif
      endif
    4 if(j.gt.1) then
         if(xt.lt.x(j)) then
            j=j-1
            go to 4
         endif
      endif
      if(i.le.j) then
        temp=x(j)
        x(j)=x(i)
        x(i)=temp
        itemp=ip(j)
        ip(j)=ip(i)
        ip(i)=itemp
        if(i.le.nx.and.j.ge.1) then
           i=i+1
           j=j-1
           go to 3
        end if
      endif
      if(j-l.le.r-i) go to 5
      if(i.lt.r) then
         s=s+1
         st(s,0)=i
         st(s,1)=r
      endif
      r=j
      go to 6
    5 if(l.lt.j) then
         s=s+1
         st(s,0)=l
         st(s,1)=j
      endif
      l=i
    6 if(l.lt.r) go to 2
      if(s.ne.0) go to 1
      return
      end
